Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 73859)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 73860)
@@ -1242,4 +1242,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Find"));
+        setShortcutScope(QApplication::translate("UIActionPool", "Log Viewer"));
         setStatusTip(QApplication::translate("UIActionPool", "Open pane with searching options"));
         setToolTip(tr("Open Find Pane (%1)").arg(shortcut().toString()));
@@ -1278,4 +1279,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Filter"));
+        setShortcutScope(QApplication::translate("UIActionPool", "Log Viewer"));
         setStatusTip(QApplication::translate("UIActionPool", "Open pane with filtering options"));
         setToolTip(tr("Open Filter Pane (%1)").arg(shortcut().toString()));
@@ -1314,4 +1316,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Bookmark"));
+        setShortcutScope(QApplication::translate("UIActionPool", "Log Viewer"));
         setStatusTip(QApplication::translate("UIActionPool", "Open pane with bookmarking options"));
         setToolTip(tr("Open Bookmark Pane (%1)").arg(shortcut().toString()));
@@ -1350,4 +1353,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Settings"));
+        setShortcutScope(QApplication::translate("UIActionPool", "Log Viewer"));
         setStatusTip(QApplication::translate("UIActionPool", "Open pane with log viewer settings"));
         setToolTip(tr("Open Settings Pane (%1)").arg(shortcut().toString()));
@@ -1386,4 +1390,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Refresh"));
+        setShortcutScope(QApplication::translate("UIActionPool", "Log Viewer"));
         setStatusTip(QApplication::translate("UIActionPool", "Refresh selected virtual machine log"));
         setToolTip(tr("Refresh Virtual Machine Log (%1)").arg(shortcut().toString()));
@@ -1422,4 +1427,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Save..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Log Viewer"));
         setStatusTip(QApplication::translate("UIActionPool", "Save selected virtual machine log"));
         setToolTip(tr("Save Virtual Machine Log (%1)").arg(shortcut().toString()));
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolSelector.cpp	(revision 73859)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolSelector.cpp	(revision 73860)
@@ -1616,4 +1616,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Take..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Snapshot Pane"));
         setStatusTip(QApplication::translate("UIActionPool", "Take a snapshot of the current virtual machine state"));
         setToolTip(tr("Take Snapshot (%1)").arg(shortcut().toString()));
@@ -1653,4 +1654,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Delete..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Snapshot Pane"));
         setStatusTip(QApplication::translate("UIActionPool", "Delete selected snapshot of the virtual machine"));
         setToolTip(tr("Delete Snapshot (%1)").arg(shortcut().toString()));
@@ -1690,4 +1692,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Restore..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Snapshot Pane"));
         setStatusTip(QApplication::translate("UIActionPool", "Restore selected snapshot of the virtual machine"));
         setToolTip(tr("Restore Snapshot (%1)").arg(shortcut().toString()));
@@ -1727,4 +1730,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Properties"));
+        setShortcutScope(QApplication::translate("UIActionPool", "Snapshot Pane"));
         setStatusTip(QApplication::translate("UIActionPool", "Open pane with the selected snapshot properties"));
         setToolTip(tr("Open Snapshot Properties (%1)").arg(shortcut().toString()));
@@ -1764,4 +1768,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Clone..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Snapshot Pane"));
         setStatusTip(QApplication::translate("UIActionPool", "Clone selected virtual machine"));
         setToolTip(tr("Clone Virtual Machine (%1)").arg(shortcut().toString()));
@@ -1835,4 +1840,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Add..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Media Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Add a disk image file"));
         setToolTip(tr("Add a Disk Image File (%1)").arg(shortcut().toString()));
@@ -1877,4 +1883,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Copy..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Media Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Copy selected disk image file"));
         setToolTip(tr("Copy Disk Image File (%1)").arg(shortcut().toString()));
@@ -1919,4 +1926,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Move..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Media Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Move selected disk image file"));
         setToolTip(tr("Move Disk Image File (%1)").arg(shortcut().toString()));
@@ -1961,4 +1969,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Remove..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Media Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Remove selected disk image file"));
         setToolTip(tr("Remove Disk Image File (%1)").arg(shortcut().toString()));
@@ -2003,4 +2012,5 @@
     {
         setName(QApplication::translate("UIActionPool", "Re&lease..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Media Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Release selected disk image file"));
         setToolTip(tr("Release Disk Image File (%1)").arg(shortcut().toString()));
@@ -2045,4 +2055,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Properties"));
+        setShortcutScope(QApplication::translate("UIActionPool", "Media Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Open pane with selected disk image file properties"));
         setToolTip(tr("Open Disk Image File Properties (%1)").arg(shortcut().toString()));
@@ -2082,4 +2093,5 @@
     {
         setName(QApplication::translate("UIActionPool", "Re&fresh..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Media Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Refresh the list of disk image files"));
         setToolTip(tr("Refresh Disk Image Files (%1)").arg(shortcut().toString()));
@@ -2148,4 +2160,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Create..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Network Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Create new host-only network"));
         setToolTip(tr("Create Host-only Network (%1)").arg(shortcut().toString()));
@@ -2185,4 +2198,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Remove..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Network Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Remove selected host-only network"));
         setToolTip(tr("Remove Host-only Network (%1)").arg(shortcut().toString()));
@@ -2222,4 +2236,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Properties"));
+        setShortcutScope(QApplication::translate("UIActionPool", "Network Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Open pane with selected host-only network properties"));
         setToolTip(tr("Open Host-only Network Properties (%1)").arg(shortcut().toString()));
@@ -2259,4 +2274,5 @@
     {
         setName(QApplication::translate("UIActionPool", "Re&fresh..."));
+        setShortcutScope(QApplication::translate("UIActionPool", "Network Manager"));
         setStatusTip(QApplication::translate("UIActionPool", "Refresh the list of host-only networks"));
         setToolTip(tr("Refresh Host-only Networks (%1)").arg(shortcut().toString()));